(** Default application. *)

(** This class defines a standard window for application, with
  a menu bar and standard menu items. *)
class app ?rflags ?resizable ?show ?x ?y ?w ?h title =
  let window = App.create_window ?rflags ?resizable ?show ?x ?y ?w ?h title in
  let vbox = Pack.vbox ~pack:window#set_child () in
  let menubar = Menu.menubar ~pack:vbox#pack () in
  let (mi_file, mi_file_label) = Menu.label_menuitem ~text:"File" () in
  let menu_file = Menu.menu ~name:"menu_file" () in
  let (mi_quit, mi_quit_label) = Menu.label_menuitem ~text: "Quit" () in
  let (mi_edit, mi_edit_label) = Menu.label_menuitem ~text:"Edit" () in
  let menu_edit = Menu.menu ~name:"menu_edit" ~pack:mi_edit#set_menu () in
  let (mi_copy, mi_copy_label) = Menu.label_menuitem
    ~name:"mi_copy" ~text: "Copy"
    ~pack:menu_edit#add_item ()
  in
  let (mi_cut, mi_cut_label) = Menu.label_menuitem
    ~name:"mi_cut" ~text: "Cut"
    ~pack:menu_edit#add_item ()
  in
  let (mi_paste, mi_paste_label) = Menu.label_menuitem
    ~name:"mi_paste" ~text: "Paste"
    ~pack:menu_edit#add_item ()
  in
  let _id = mi_quit#connect Widget.Activated
    (fun () -> App.quit ())
  in
  object
    method window = window
    method mainbox : unit Pack.box = vbox
    method menubar = menubar
    method mi_file = mi_file
    method menu_file = menu_file
    method mi_file_label = mi_file_label
    method mi_quit = mi_quit
    method mi_quit_label = mi_quit_label

    method mi_edit = mi_edit
    method mi_edit_label = mi_edit_label
    method menu_edit = menu_edit
    method mi_copy = mi_copy
    method mi_copy_label = mi_copy_label
    method mi_cut = mi_cut
    method mi_cut_label = mi_cut_label
    method mi_paste = mi_paste
    method mi_paste_label = mi_paste_label

    method run = App.run ()

    initializer
      menu_file#add_item mi_quit ;
      mi_file#set_menu menu_file ;
      menubar#add_item mi_file ;
      menubar#add_item mi_edit ;

  end