open Stk
open Stk.Misc

(*let () = Logs.Src.set_level Log.log_src (Some Logs.Debug)
let () = Logs.Src.set_level Texture.log_src (Some Logs.Debug)*)
let () = Logs.set_reporter (Misc.lwt_reporter ())

let _ = Tsdl.Sdl.(init Init.(video+events))
let () = Lwt_main.run (App.init ())

let mk_win () =
  let (win,scr) = App.create_scrolled_window
    ~flags:Tsdl.Sdl.Window.resizable
    ~w: 400 ~h: 600 "stk canvas" in
  let vbox = Pack.vbox ~pack:scr#set_child () in
  let text = "Click me I'm famous" in
  let (b,label) = Stk.Button.text_button ~name:"mybutton"
    ~text ~pack:vbox#pack ()
  in
  let (tb,tlabel) = Stk.Button.text_togglebutton ~name:"mytogglebutton"
    ~text:"Toggle button" ~pack:vbox#pack ()
  in
  let (cb,clabel) = Stk.Button.text_checkbutton ~name:"mycheckbutton"
    ~text:"Check button" ~pack:vbox#pack ()
  in
  let hbox_radio = Pack.hbox ~pack:vbox#pack () in
  let group = Button.group () in
  let (rb1,_) = Stk.Button.text_radiobutton ~group ~text:"choice 1" ~pack:hbox_radio#pack () in
  rb1#set_indicator_inactive_char (Uchar.of_int 9671) ;
  rb1#set_indicator_active_char (Uchar.of_int 9672) ;
  let (rb2,_) = Stk.Button.text_radiobutton ~group ~text:"choice 2" ~pack:hbox_radio#pack () in
  rb2#set_indicator_inactive_char (Uchar.of_int 9655) ;
  rb2#set_indicator_active_char (Uchar.of_int 9654) ;
  let (rb3,_) = Stk.Button.text_radiobutton ~group ~text:"choice 3" ~pack:hbox_radio#pack () in
  rb3#set_indicator_inactive_char (Uchar.of_int 9676) ;
  rb3#set_indicator_active_char (Uchar.of_int 9677) ;

  let _id = b#connect Stk.Widget.Activated
    (fun _ -> Stk.Log.app (fun m -> m "activated %S" label#text))
  in
  let _id = b#connect Stk.Widget.Button_pressed
    (fun _ -> label#set_text "button pressed..." ; true)
  in
  let _id = b#connect Stk.Widget.Button_released
    (fun _ -> label#set_text text ; true)
  in
  let _id = tb#connect Stk.(Object.Prop_changed Button.active)
    (fun ~prev ~now -> Stk.Log.app (fun m -> m "%s is active: %b" tb#me now))
  in
  let _id = group#connect Stk.(Object.Prop_changed Button.active_widget)
    (fun ~prev ~now -> Stk.Log.app (fun m -> m "active widget in group %s is now %a" group#me Stk.Widget.pp now))
  in
  win

let main () =
  let _win = mk_win () in
  Lwt.join [Stk.App.run ()]

let () =
  Lwt_main.run (main ())