open Stk
open Stk.Misc

let () = Logs.Src.set_level Log.log_src (Some Logs.Debug)

let () = Logs.set_reporter (Misc.lwt_reporter ())

let _ = Tsdl.Sdl.(init Init.(video+events))
let () = Lwt_main.run(App.init())

let test_textures rend =
  Random.self_init();
  for i = 1 to 100_000 do
    let w = 1000 in
    let h = 800 in
    ignore(w,h);
    let t = Texture.create rend ~w ~h in
    Texture.destroy t;
    (*let> t = Tsdl.Sdl.create_texture rend
       Tsdl.Sdl.Pixel.format_rgba8888
       Tsdl.Sdl.Texture.access_target
       ~w ~h
    in
    Tsdl.Sdl.destroy_texture t*)
  done;
  Gc.major()


let mk_win () =
  let (win,vp) = App.create_scrolled_window
    ~flags:Tsdl.Sdl.Window.resizable
    ~w: 400 ~h: 600 "stk canvas" in
  test_textures win#renderer ;
  (*let%lwt hbox = Stk.Pack.hbox ~pack:vp#set_child () in*)
  win

let main () =
  let root =
    if Array.length Sys.argv > 1 then
      Sys.argv.(1)
    else
      Filename.current_dir_name
  in
  let _win = mk_win () in
  Lwt.join [Stk.App.run ()]

let () = Lwt_main.run (main ())