open Stk
open Stk.Misc

let () = Logs.set_reporter (Misc.lwt_reporter ())
let () = Random.init 20
let _ = Tsdl.Sdl.(init Init.(video+events))
let () = Lwt_main.run(App.init())


let main( ) =
  let w = App.create_window ~resizable:true ~w: 600 ~h: 600 "stk test_frame" in
  let vbox = Pack.vbox ~pack:w#set_child () in
  let hbox1 = Pack.hbox ~pack:vbox#pack () in
  let hbox2 = Pack.hbox ~pack:vbox#pack () in
  let mk_props () =
    let p = Props.empty () in
    Props.(
     set p bg_color (Color.random());
     set p fill true ;
     set p margin (trbl__ 4);
     set p Frame.border_width 4;
    );
    p
  in
  let mk_f ~pack = Frame.frame ~props:(mk_props()) ~pack () in
  let f1_1 = mk_f ~pack:hbox1#pack in
  f1_1#set_label (Some (Text.label ~props:(mk_props()) ~text:"Label" ())#coerce);
  f1_1#set_child (Pack.hbox ~props:(mk_props()) ())#coerce ;
  let f1_2 = mk_f ~pack:hbox1#pack in
  let f2_1 = mk_f ~pack:hbox2#pack in
  f2_1#set_label (Some (Text.label ~props:(mk_props()) ~text:"Label" ())#coerce);
  let f2_2 = mk_f ~pack:hbox2#pack in
  f2_2#set_label (Some (Text.label ())#coerce);
  Lwt.join [Stk.App.run ()]

let () = Lwt_main.run (main ())