open Stk
open Stk.Misc

let () = Logs.set_reporter (Misc.lwt_reporter ())

let _ = Tsdl.Sdl.(init Init.(video+events))
let _ = Tsdl_image.Image.(init Init.(jpg+png))
let () = Lwt_main.run(App.init())

let main () =
  let win = App.create_window
    ~resizable:true ~w: 400 ~h: 400 "stk image"
  in
  let hpaned = Pack.hpaned ~pack:win#set_child () in
  let scr = Bin.scrollbox ~pack:hpaned#pack () in
  let image2 = Image.image ~pack:scr#set_child ~file:Sys.argv.(1) () in

  let bin = Bin.bin ~pack:hpaned#pack () in
  let image = Image.image ~pack:bin#set_child
    ~width:400 ~height:400 ~file:Sys.argv.(1) ()
  in
  let resize_image () =
    let g = bin#g_inner in
    image#set_width g.w ;
    image#set_height g.h
  in
  resize_image ();

(*    let image = Image.image ~pack:vp#set_child ~file:Sys.argv.(1) () in*)
  let _ = bin#connect Widget.Geometry_changed resize_image in
  Lwt.join [Stk.App.run ()]

let () = Lwt_main.run (main ())