open Stk
open Stk.Misc

let () = Logs.set_reporter (Misc.lwt_reporter ())

let text = "😀 Lorem ipsum dolor sit amet, consectetur adipiscing elit.
Proin vel nisi a enim porttitor dignissim. Sed lacinia orci
eros, sed viverra metus venenatis sit amet. Nulla sed
quam quam. Donec nec justo maximus, consequat orci eu, lobortis ex.
Proin interdum porttitor lectus, vel scelerisque nunc vehicula
cursus. Ut blandit vehicula diam. In a ultricies
metus. Aenean eget libero commodo nulla placerat sollicitudin
eleifend id dui. Aliquam erat volutpat. Aliquam erat
volutpat. Proin bibendum aliquam facilisis. Suspendisse
potenti. Vivamus vel viverra nunc. Maecenas aliquam egestas
magna, vel pellentesque ipsum congue id. Sed in leo sit
amet turpis dictum ultrices. Nullam varius nisi augue,
sit amet efficitur massa consectetur a."

let main () =
  let%lwt () = App.init () in
  let win = App.create_window ~flags:Tsdl.Sdl.Window.resizable ~w:400 ~h:600 "test paned" in
  let hpaned = Pack.hpaned ~pack:win#set_child () in
  let vpaned = Pack.vpaned ~pack:hpaned#pack () in
  let make_tv (p:Pack.paned) =
    let scr = Bin.scrollbox ~pack:(p#pack ~pos:0) () in
    let tv = Textview.textview ~pack:scr#set_child () in
    Props.set_font_size tv#props 16;
    tv#insert text ;
    tv
  in
  let tv1 = make_tv hpaned in
  let tv2 = make_tv hpaned in
  tv2#set_theme "cobalt" ;
  let tv3 = make_tv vpaned in
  let tv4 = make_tv vpaned in
  let tv5 = make_tv vpaned in
  let tv6 = Textview.textview ~pack:vpaned#pack () in
  tv6#insert text ;

  let%lwt () = Lwt.join [Stk.App.run ()] in
  Lwt.return_unit

let () = Lwt_main.run (main ())
