open Stk
open Stk.Misc

let () = Logs.set_reporter (Misc.lwt_reporter ())

let _ = Tsdl.Sdl.(init Init.(video+events))
let () = Lwt_main.run(App.init())

let main () =
  let (win,vp) = App.create_scrolled_window
    ~resizable:true ~w: 400 ~h: 600 "stk canvas"
  in
  let box = Pack.hbox ~pack:vp#set_child () in
  let add_scale orientation =
    let pack w = match orientation with
    | Props.Vertical -> box#pack ~hexpand:0 w
    | Props.Horizontal -> box#pack ~vexpand:0 w
    in
    let sc = Range.range ~orientation ~range:(0., 100.) ~pack () in
    let label = Text.label ~pack:box#pack () in
    sc#set_value 25. ;
    ignore(sc#connect (Object.Prop_changed Range.value)
      (fun ~prev ~now -> label#set_text (string_of_float now)));
    ()
  in
  add_scale Props.Vertical ;
  add_scale Props.Horizontal ;
  Lwt.join [Stk.App.run ()]

let () = Lwt_main.run (main ())